\name{GeneMaxVarFun}
\alias{GeneMaxVarFun}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Function to compute the Affymetrix identifiers that map to the same Gene Symbol with the maximum variability between phenotypes.
}
\description{
Some Affymetrix identifiers map to the same gene symbol. This implies that there exist more than one row number from the data set associated to a gene symbol.
This function computes the respective row number associated to the Affymetrix identifier the presents the maximum variability across phenotypes for every group of Affymetrix identifiers mapping to gene symbols.
}
\usage{
GeneMaxVarFun(unique.genes.data,genes.data,data,phenotype.a,phenotype.b)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{unique.genes.data}{
A vector with all the unique Gene Symbols present in the data.
}
\item{genes.data}{
A vector with all the Gene Symbols of the data.
}
  \item{data}{
Data set of interest in the form of a matrix: columns for patients, rows for Affymetrix identifiers.
}
  \item{phenotype.a}{
Vector of indices with the column identifiers of phenotype a.
}
  \item{phenotype.b}{
Vector of indices with the column identifiers of phenotype b.
}
}
\details{
This function captures the row numbers associated to the Affymetrix identifiers with the maximum variability between phenotypes for every group of Affymetrix identifiers mapping to gene symbols.
}
\value{
This function returns a vector containing the following results:
%%  If it is a LIST, use
 \item{IndexMaxVar}{A vector with the row number ids of the respective Affymetrix identifiers with the maximum variability across phenotypes.}
}
%%\references{
%% ~put references to the literature/web site here ~
%%}
\author{
A. Quiroz-Zarate and John Quackenbush.
}

\seealso{
 See the \code{GeneGroupAnalysis} Vignette for examples on how to use this function.
}
\examples{
#- For an example on the use of this function go to:
#- GeneGroups.CS

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%%\keyword{ ~kwd1 }
%%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
