//
//  Funciones.h
//  GibbsCS
//
//  Created by Alejandro Quiroz on 1/9/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#include "Auxiliares.h"
#include "libmat.h"

//=============== Para sigma

double *SgmYFunCS(int noRow, int noCol, double *GrpSzs, double **YMu, double *Param, double L0, double V0, double *resI)
{
    int i,j;
    //double *YMuVec,*resI;
    //YMuVec=array1(noCol);
    //resI=array1(noRow);
    
    double *YMuVec;
    YMuVec=array1M(noCol);
    
    for(i=0;i<noRow;i++)
    {
        for(j=0;j<noCol;j++)
        {
            YMuVec[j]=YMu[i][j];
        }
        resI[i]=SgmYAuxCS(noCol, GrpSzs[i], YMuVec, Param[i], L0, V0);
    }
    
    free(YMuVec);
    return resI;
}

//=============== Para Beta

double *BetaFunCS(int noRow, int noColA, int noColB, double **YMuA, double **YMuB, double *GrpSzs, double *AlfaVec, double *SgmA, double *SgmB, double *resI)
{
    int i,j;
    //double *YMuVecA, *YMuVecB,*resI;
    //YMuVecA=array1(noColA);
    //YMuVecB=array1(noColB);
    //resI=array1(noRow);
    double *YMuVecA, *YMuVecB;
    YMuVecA=array1M(noColA);
    YMuVecB=array1M(noColB);
    
    for(i=0;i<noRow;i++)
    {
        for(j=0;j<noColA;j++)
        {
            YMuVecA[j]=YMuA[i][j];
        }
        for(j=0;j<noColB;j++)
        {
            YMuVecB[j]=YMuB[i][j];
        }
        resI[i]=BetaAuxCS(noColA,noColB,GrpSzs[i],YMuVecA,YMuVecB,AlfaVec[i],SgmA[i],SgmB[i]);
    }
    
    free(YMuVecA);
    free(YMuVecB);
    return resI;
}

//=============== Para Alfa

double *AlfaFunCS(int noRow, int noColB, double **YMuB, double *GrpSzs, double *BetaVec, double *SgmB, double Sgm, double rho, double mm, double *resI)
{
    int i,j;
    //double *YMuVecB,*resI;
    //YMuVecB=array1(noColB);
    //resI=array1(noRow);
    double *YMuVecB;
    YMuVecB=array1M(noColB);

    for(i=0;i<noRow;i++)
    {
        for(j=0;j<noColB;j++)
        {
            YMuVecB[j]=YMuB[i][j];
        }
        resI[i]=AlfaAuxCS(noColB,GrpSzs[i],YMuVecB,BetaVec[i],SgmB[i],Sgm,rho,mm);
    }
    
    free(YMuVecB);
    return resI;
}

//=============== Para Pi

double *PiFunCS(int noRow, double *AlfaVec, double rho, double aa, double mm, double *resI)
{
    int i;
    double forma1,forma2,shape1,shape2,c0,prob,aux,alea;
    //double *resI;
    //resI=array1(noRow);
    
    forma1=aa*mm;
    forma2=aa*(1-mm);
    
    for(i=0;i<noRow;i++)
    {
        resI[i]=0;
        if(AlfaVec[i]==0){
            c0=(1-mm)*rho/(1-rho);
            prob=c0/(1+c0);
            
            GetRNGstate();
            alea=runif(0,1);
            PutRNGstate();
        
            if(alea<prob){
                shape1=forma1;
                shape2=forma2+1;
                GetRNGstate();
                aux=rbeta(shape1,shape2);
                PutRNGstate();
                resI[i]=aux;
            }
        }
        else{
            shape1=forma1+1;
            shape2=forma2;
            GetRNGstate();
            aux=rbeta(shape1,shape2);
            PutRNGstate();
            resI[i]=aux;
        }
    }
    return resI;
}

//=============== Para SgmAlfa

double SgmAlfaFunCS(int noRow,double *AlfaVec, double aa, double bb)
{
    int i;
    double forma,scala,rate,suma,aux,aux2,resI;
    
    forma=(noRow/2)+aa;
    suma=0;
    for(i=0;i<noRow;i++)
    {
        aux=AlfaVec[i]*AlfaVec[i];
        suma=suma+aux;
    }
    
    scala=(suma/2)+bb;
    rate=1/scala;
    
    GetRNGstate();
    resI=rgamma(forma,rate);
    PutRNGstate();
    
    resI=1/resI;
    return resI;
}

//=============== Para Rho

double RhoFunCS(int noRow, double *Pi, double ss, double rr)
{
    int i;
    double shape1,shape2,suma,aux,resI;
    
    suma=0;
    for(i=0;i<noRow;i++)
    {
        if(Pi[i]==0){
            suma=suma+1; 
        }
    }
    aux=noRow-suma;
    shape1=ss*rr+aux;
    shape2=ss*(1-rr)+(noRow-aux);
    
    GetRNGstate();
    resI=rbeta(shape1,shape2);
    PutRNGstate();
    
    return resI;
}



